| TagLib 1.13 |  |

Public Member Functions | Static Public Member Functions | Protected Member Functions | Friends | List of all members
TagLib::ID3v2::TableOfContentsFrame Class Reference

An implementation of ID3v2 table of contents frames. More...

`#include <tableofcontentsframe.h>`

Inheritance diagram for TagLib::ID3v2::TableOfContentsFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::TableOfContentsFrame:
[legend]

## Public Member Functions
| TableOfContentsFrame (const ID3v2::Header *tagHeader, const ByteVector &data)
| TableOfContentsFrame (const ByteVector &elementID, const ByteVectorList &children=ByteVectorList(), const FrameList &embeddedFrames=FrameList())
| ~TableOfContentsFrame ()
ByteVector | elementID () const
bool | isTopLevel () const
bool | isOrdered () const
unsigned int | entryCount () const
ByteVectorList | childElements () const
void | setElementID (const ByteVector &eID)
void | setIsTopLevel (const bool &t)
void | setIsOrdered (const bool &o)
void | setChildElements (const ByteVectorList &l)
void | addChildElement (const ByteVector &cE)
void | removeChildElement (const ByteVector &cE)
const FrameListMap & | embeddedFrameListMap () const
const FrameList & | embeddedFrameList () const
const FrameList & | embeddedFrameList (const ByteVector &frameID) const
void | addEmbeddedFrame (Frame *frame)
void | removeEmbeddedFrame (Frame *frame, bool del=true)
void | removeEmbeddedFrames (const ByteVector &id)
virtual String | toString () const
PropertyMap | asProperties () const
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
ByteVector | frameID () const
unsigned int | size () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual String | toString () const =0
ByteVector | render () const
TAGLIB_DEPRECATED | Header (const ByteVector &data, bool synchSafeInts)
| Header (const ByteVector &data, unsigned int version=4)
virtual | ~Header ()
TAGLIB_DEPRECATED void | setData (const ByteVector &data, bool synchSafeInts)
void | setData (const ByteVector &data, unsigned int version=4)
ByteVector | frameID () const
void | setFrameID (const ByteVector &id)
unsigned int | frameSize () const
void | setFrameSize (unsigned int size)
unsigned int | version () const
void | setVersion (unsigned int version)
bool | tagAlterPreservation () const
void | setTagAlterPreservation (bool discard)
bool | fileAlterPreservation () const
bool | readOnly () const
bool | groupingIdentity () const
bool | compression () const
bool | encryption () const
bool | unsynchronisation () const
bool | dataLengthIndicator () const
ByteVector | render () const
TAGLIB_DEPRECATED bool | frameAlterPreservation () const

## Static Public Member Functions
static TableOfContentsFrame * | findByElementID (const Tag *tag, const ByteVector &eID)
static TableOfContentsFrame * | findTopLevel (const Tag *tag)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static Frame * | createTextualFrame (const String &key, const StringList &values)
static unsigned int | headerSize ()
static unsigned int | headerSize (unsigned int version)
static ByteVector | textDelimiter (String::Type t)
static unsigned int | size ()
static unsigned int | size (unsigned int version)

## Protected Member Functions
virtual void | parseFields (const ByteVector &data)
virtual ByteVector | renderFields () const
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
Header * | header () const
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
virtual void | parseFields (const ByteVector &data)=0
virtual ByteVector | renderFields () const =0
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=0)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const
PropertyMap | asProperties () const

## Friends
class | FrameFactory

## Additional Inherited Members
Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static String::Type | checkEncoding (const StringList &fields, String::Type encoding)
static String::Type | checkEncoding (const StringList &fields, String::Type encoding, unsigned int version)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)
static String | keyToTXXX (const String &)
static String | txxxToKey (const String &)
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An implementation of ID3v2 table of contents frames.

This is an implementation of ID3v2 table of contents frames. Purpose of this frame is to allow a table of contents to be defined.

## Constructor & Destructor Documentation

## ◆ TableOfContentsFrame() [1/2]

TagLib::ID3v2::TableOfContentsFrame::TableOfContentsFrame | ( | const ID3v2::Header * | tagHeader,
|  | const ByteVector & | data
| ) |  |

Creates a table of contents frame based on data. tagHeader is required as the internal frames are parsed based on the tag version.

## ◆ TableOfContentsFrame() [2/2]

TagLib::ID3v2::TableOfContentsFrame::TableOfContentsFrame | ( | const ByteVector & | elementID,
|  | const ByteVectorList & | children = `ByteVectorList()`,
|  | const FrameList & | embeddedFrames = `FrameList()`
| ) |  |

Creates a table of contents frame with the element ID elementID, the child elements children and embedded frames, which become owned by this frame, in embeddedFrames.

## ◆ ~TableOfContentsFrame()

TagLib::ID3v2::TableOfContentsFrame::~TableOfContentsFrame | ( |  | ) |

Destroys the frame.

## Member Function Documentation

## ◆ addChildElement()

void TagLib::ID3v2::TableOfContentsFrame::addChildElement | ( | const ByteVector & | cE | ) |

Adds cE to list of child elements of the frame.

See also
  childElements()

## ◆ addEmbeddedFrame()

void TagLib::ID3v2::TableOfContentsFrame::addEmbeddedFrame | ( | Frame * | frame | ) |

Add an embedded frame to the CTOC frame. At this point the CTOC frame takes ownership of the embedded frame and will handle freeing its memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ asProperties()

PropertyMap TagLib::ID3v2::TableOfContentsFrame::asProperties | ( |  | ) | const

## ◆ childElements()

ByteVectorList TagLib::ID3v2::TableOfContentsFrame::childElements | ( |  | ) | const

Returns list of child elements of the frame.

See also
  setChildElements()

## ◆ elementID()

ByteVector TagLib::ID3v2::TableOfContentsFrame::elementID | ( |  | ) | const

Returns the elementID of the frame. Element ID is a null terminated string, however it's not human-readable.

See also
  setElementID()

## ◆ embeddedFrameList() [1/2]

const FrameList & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameList | ( |  | ) | const

Returns a reference to the embedded frame list. This is an FrameList of all of the frames embedded in the CTOC frame in the order that they were parsed.

This can be useful if for example you want iterate over the CTOC frame's embedded frames in the order that they occur in the CTOC frame.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

## ◆ embeddedFrameList() [2/2]

const FrameList & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameList | ( | const ByteVector & | frameID | ) | const

Returns the embedded frame list for frames with the id frameID or an empty list if there are no embedded frames of that type. This is just a convenience and is equivalent to:

embeddedFrameListMap()[frameID];
TagLib::ID3v2::Frame::frameID
ByteVector frameID() const
TagLib::ID3v2::TableOfContentsFrame::embeddedFrameListMap
const FrameListMap & embeddedFrameListMap() const

See also
  embeddedFrameListMap()

## ◆ embeddedFrameListMap()

const FrameListMap & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameListMap | ( |  | ) | const

Returns a reference to the frame list map. This is an FrameListMap of all of the frames embedded in the CTOC frame.

This is the most convenient structure for accessing the CTOC frame's embedded frames. Many frame types allow multiple instances of the same frame type so this is a map of lists. In most cases however there will only be a single frame of a certain type.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

See also
  embeddedFrameList()

## ◆ entryCount()

unsigned int TagLib::ID3v2::TableOfContentsFrame::entryCount | ( |  | ) | const

Returns count of child elements of the frame. It always corresponds to size of child elements list.

See also
  childElements()

## ◆ findByElementID()

static TableOfContentsFrame * TagLib::ID3v2::TableOfContentsFrame::findByElementID | ( | const Tag * | tag,
|  | const ByteVector & | eID
| ) |  |
| static

CTOC frames each have a unique element ID. This searches for a CTOC frame with the element ID eID and returns a pointer to it. This can be used to link together parent and child CTOC frames.

See also
  elementID()

## ◆ findTopLevel()

static TableOfContentsFrame * TagLib::ID3v2::TableOfContentsFrame::findTopLevel | ( | const Tag * | tag | ) |
| static

CTOC frames each contain a flag that indicates, if CTOC frame is top-level (there isn't any frame, which contains this frame in its child elements list). Only a single frame within tag can be top-level. This searches for a top-level CTOC frame.

See also
  isTopLevel()

## ◆ isOrdered()

bool TagLib::ID3v2::TableOfContentsFrame::isOrdered | ( |  | ) | const

Returns true, if the child elements list entries are ordered.

See also
  setIsOrdered()

## ◆ isTopLevel()

bool TagLib::ID3v2::TableOfContentsFrame::isTopLevel | ( |  | ) | const

Returns true, if the frame is top-level (doesn't have any parent CTOC frame).

See also
  setIsTopLevel()

## ◆ parseFields()

virtual void TagLib::ID3v2::TableOfContentsFrame::parseFields | ( | const ByteVector & | data | ) |
| protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ removeChildElement()

void TagLib::ID3v2::TableOfContentsFrame::removeChildElement | ( | const ByteVector & | cE | ) |

Removes cE to list of child elements of the frame.

See also
  childElements()

## ◆ removeEmbeddedFrame()

void TagLib::ID3v2::TableOfContentsFrame::removeEmbeddedFrame | ( | Frame * | frame,
|  | bool | del = `true`
| ) |  |

Remove an embedded frame from the CTOC frame. If del is true the frame's memory will be freed; if it is false, it must be deleted by the user.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ removeEmbeddedFrames()

void TagLib::ID3v2::TableOfContentsFrame::removeEmbeddedFrames | ( | const ByteVector & | id | ) |

Remove all embedded frames of type id from the CTOC frame and free their memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## ◆ renderFields()

virtual ByteVector TagLib::ID3v2::TableOfContentsFrame::renderFields | ( |  | ) | const
| protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

## ◆ setChildElements()

void TagLib::ID3v2::TableOfContentsFrame::setChildElements | ( | const ByteVectorList & | l | ) |

Sets list of child elements of the frame to l.

See also
  childElements()

## ◆ setElementID()

void TagLib::ID3v2::TableOfContentsFrame::setElementID | ( | const ByteVector & | eID | ) |

Sets the elementID of the frame to eID. If eID isn't null terminated, a null char is appended automatically.

See also
  elementID()

## ◆ setIsOrdered()

void TagLib::ID3v2::TableOfContentsFrame::setIsOrdered | ( | const bool & | o | ) |

Sets, if the child elements list entries are ordered.

See also
  isOrdered()

## ◆ setIsTopLevel()

void TagLib::ID3v2::TableOfContentsFrame::setIsTopLevel | ( | const bool & | t | ) |

Sets, if the frame is top-level (doesn't have any parent CTOC frame).

See also
  isTopLevel()

## ◆ toString()

virtual String TagLib::ID3v2::TableOfContentsFrame::toString | ( |  | ) | const
| virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Implements TagLib::ID3v2::Frame.

## Friends And Related Function Documentation

## ◆ FrameFactory

friend class FrameFactory
| friend

The documentation for this class was generated from the following file:

- tableofcontentsframe.h